<template>
  <CommandExecuteContext v-bind:commands="commandContext"></CommandExecuteContext>
</template>

<script>
  import UserCommands from "../../../commands/UserCommands"
  import CommandExecuteContext from '../../../commands/CommandExecuteContext'
  import ServiceTypeService from '@/domain/services/Business/ServiceTypeService.js'
  import HelperUtil from "../../../utils/HelperUtil";

  export default {
    props: ['command'],

    components: {
      CommandExecuteContext,
    },

    data: function () {
      return {
        deleteList: this.command.target,

        //命令
        commandContext: {},

        confirmFlag: {
          confirm: false,
        },
      }
    },
    methods: {
      open() {
        this.InfoTip.conformTip(this, HelperUtil.getCheckStatusCodeObjectByCode(this.successCode.DELETE_CONFIRM)).then(() => {
          this.deleteServiceType()
        });
//        this.command.done()
      },

      close() {
        this.command.done();
      },

      //删除业务类型
      deleteServiceType() {
        let _this = this;
        console.log("删除业务类型");
        //调用函数
        console.log(JSON.stringify(this.deleteList));
        let loadingInstance = _this.Loading.openLoading();
        ServiceTypeService.deleteServiceTypes(this.deleteList[0]).then(result => {
          //成功
          console.log("删除成功")
          _this.Loading.closeLoading(loadingInstance);
          _this.InfoTip.successTip(_this, HelperUtil.getStatusCodeObjectByCode(_this.successCode.DELETE_CODE));
          _this.close()
        }).catch(err => {
          //失败
          _this.Loading.closeLoading(loadingInstance);
          _this.InfoTip.errorTip(_this, err);
          _this.close()
        })
      }
    },
    watch: {
      commandContext (newVal, oldVal){
        let _this = this;
        if(_this.confirmFlag.confirm){
          this.open();
          this.confirmFlag.confirm = false
        }
        else{
          if(JSON.stringify(newVal) === '{}'){
            _this.close()
          }
        }
        deep: true
      },
    },

    created() {
      this.confirmUserCommand.execute();
    },

    computed: {
      confirmUserCommand(){
        this.confirmFlag.confirm = false;
        return UserCommands.confirmUserCommand(this.commandContext, this.confirmFlag)
      },
    },
  }
</script>
